/**
 * Diashapes -- Assistant to download and install Dia shapes
 * Copyright (C) 2007, 2008 Steffen Macke
 *
 * diashapes.h: Function prototypes and structure definitions
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef DIASHAPES_H_
#define DIASHAPES_H_

static void cleanup ();
static void extract (GtkProgressBar *, GtkLabel *, gdouble, GtkWindow *a);
static gboolean fetch_sheet(const gchar *, GtkWindow *);
static void fetch_sheets(GtkWidget *, gpointer);
static gchar *get_dia_dir ();
static void usage (void);
static void cursor_changed (GtkTreeView *, GtkAssistant *);
static void assistant_prepare (GtkAssistant *, GtkWidget *, gpointer);
static void assistant_cancel (GtkAssistant *, gpointer);
static void assistant_close (GtkAssistant *, gpointer);
static GtkWidget *create_view_and_model (gchar * sheetpath, GtkWindow *assistant);
static GtkTreeModel *create_and_fill_model (gchar * sheetpath, GtkWindow *assistant);
static size_t write_data(void *, size_t, size_t, void *);
static void extract_gsf_infile(GsfInfile *, gchar *, GtkWindow *);

typedef struct
{
  GtkWidget *widget;
  gint index;
  const gchar *title;
  GtkAssistantPageType type;
  gboolean complete;
} PageInfo;

enum
{
  COL_NAME = 0,
  COL_DESCRIPTION,
  COL_CREATOR,
  COL_WEBSITE,
  COL_DOWNLOAD,
  NUM_COLS
};


#endif /*DIASHAPES_H_ */
